' Add referce to System.DirectoryServices

Imports System.Runtime.InteropServices
Imports System.Runtime.InteropServices.Marshal
Imports System.ComponentModel
Imports System.DirectoryServices
Imports System.Collections.Specialized

Class EnumNet

#Region "API Region"
    'NET_API_STATUS NetServerEnum(
    '  LPCWSTR servername,
    '  DWORD level,
    '  LPBYTE* bufptr,
    '  DWORD prefmaxlen,
    '  LPDWORD entriesread,
    '  LPDWORD totalentries,
    '  DWORD servertype,
    '  LPCWSTR domain,
    '  LPDWORD resume_handle
    ');
    Declare Unicode Function NetServerEnum Lib "Netapi32.dll" ( _
        ByVal servername As Integer, _
        ByVal level As Integer, _
        ByRef bufptr As IntPtr, _
        ByVal prefmaxlen As Integer, _
        ByRef entriesread As Integer, _
        ByRef totalentries As Integer, _
        ByVal servertype As Integer, _
        ByVal domain As String, _
        ByRef resume_handle As Integer _
    ) As Integer

    'NET_API_STATUS NetApiBufferFree(
    '  LPVOID Buffer
    ');
    Declare Function NetApiBufferFree Lib "Netapi32.dll" ( _
        ByVal Buffer As IntPtr _
    ) As Integer

    'typedef struct _SERVER_INFO_101 {
    '  DWORD sv101_platform_id;
    '  LPWSTR sv101_name;
    '  DWORD sv101_version_major;
    '  DWORD sv101_version_minor;
    '  DWORD sv101_type;
    '  LPWSTR sv101_comment;
    '} SERVER_INFO_101, *PSERVER_INFO_101, *LPSERVER_INFO_101;
    Private Structure Server_info_101
        Dim sv101_platform_id As Integer
        <MarshalAsAttribute(UnmanagedType.LPWStr)> Dim sv101_name As String
        Dim sv101_version_major As Integer
        Dim sv101_version_minor As Integer
        Dim sv101_type As Integer
        <MarshalAsAttribute(UnmanagedType.LPWStr)> Dim sv101_comment As String
    End Structure

    Const SV_TYPE_ALL As Long = &HFFFFFFFF
    Const MAJOR_VERSION_MASK As Long = &HF
#End Region

    Public Record_count As Integer

    Public Sub GetEnunNet(ByRef dt As DataTable, ByVal StartDom As String, ByVal filter As String)
        Dim level, MaxLenPref, ret, i As Integer
        Dim EntriesRead, TotalEntries, ResumeHandle As Integer
        Dim BufPtr, iPtr As IntPtr
        Dim temp As String
        Dim dr As DataRow
        Dim TempNet As New Server_info_101
        Dim CurDate As Date

        ' let's do it!
        CurDate = Now
        MaxLenPref = -1
        level = 101
        ret = NetServerEnum(0, level, BufPtr, MaxLenPref, EntriesRead, TotalEntries, SV_TYPE_ALL, StartDom, ResumeHandle)
        If ret <> 0 Then
            ' record an error message
            Record_count = Record_count + 1
            dr = dt.NewRow
            dr("PCDomain") = Left(StartDom, 50)
            dr("CurrentDate") = CurDate
            dr("PCComment") = "Error! " & ret
            dt.Rows.Add(dr)
        Else
            ' record the results in our database
            For i = 0 To EntriesRead - 1

                ' some wizardry to "walk" the array of NETRESOURCE structures
                iPtr = New IntPtr(BufPtr.ToInt32 + (i * Marshal.SizeOf(TempNet)))
                TempNet = CType(Marshal.PtrToStructure(iPtr, GetType(Server_info_101)), Server_info_101)

                temp = TempNet.sv101_name
                If filter = "" Or temp.ToUpper = filter.ToUpper Or temp.ToUpper Like filter.ToUpper Then
                    ' add it to our database
                    Record_count = Record_count + 1
                    dr = dt.NewRow
                    dr("PCDomain") = Left(StartDom, 50)
                    dr("PCName") = Left(temp, 50)
                    dr("CurrentDate") = CurDate
                    dr("OSVersion") = CDbl(CStr(TempNet.sv101_version_major And MAJOR_VERSION_MASK) & "." & CStr(TempNet.sv101_version_minor))
                    dr("OSType") = Left(BuildType(TempNet.sv101_type), 150)
                    If Not IsNothing(TempNet.sv101_comment) AndAlso TempNet.sv101_comment <> "" Then
                        dr("PCComment") = Left(TempNet.sv101_comment, 100)
                    End If
                    dt.Rows.Add(dr)

                    ' keep them entertained
                    Console.Write(".")
                End If
            Next
            NetApiBufferFree(BufPtr)
        End If
    End Sub

    Private Function BuildType(ByVal t As Integer) As String
        Dim Buf As String
        Dim mask As Long
        Dim i As Integer

        Buf = ""
        If (t And &H1000) <> 0 Then
            Buf = "WinNT, "
        End If
        If (t And &H400000) <> 0 Then
            Buf = "Win9x, "
        End If
        If (t And &H2000) <> 0 And (Buf <> "Win9x, ") Then
            Buf = "WinFWG, "
        End If

        For i = 0 To 30
            mask = CLng(2 ^ i)
            If (t And mask) <> 0 Then
                Select Case i
                    Case 2
                        Buf = Buf & "SQL, "
                    Case 3
                        Buf = Buf & "PDC, "
                    Case 4
                        Buf = Buf & "BDC, "
                    Case 5
                        Buf = Buf & "Time, "
                    Case 6
                        Buf = Buf & "Apple, "
                    Case 7
                        Buf = Buf & "Novel, "
                    Case 8
                        Buf = Buf & "Member, "
                    Case 9
                        Buf = Buf & "Print, "
                    Case 10
                        Buf = Buf & "RAS, "
                    Case 11
                        Buf = Buf & "Xenix, "
                    Case 14
                        Buf = Buf & "Netware, "
                    Case 15
                        Buf = Buf & "Server, "
                    Case 18
                        Buf = Buf & "Browse, "
                End Select
            End If
        Next

        ' zap the trailing comma and space
        If Len(Buf) > 2 Then
            Buf = Left(Buf, Len(Buf) - 2)
        End If

        Return Buf
    End Function

    '
    ' Enumerate the user accounts
    '
    Public Sub GetEnunNet(ByVal dt As DataTable, ByVal DomainName As String, ByVal OU_Name As String, ByVal Filter As String)
        Dim entry, de As DirectoryEntry
        Dim srch As DirectorySearcher
        Dim result As SearchResult
        Dim ldap, buf, ans(-1) As String
        Dim dr As DataRow
        Dim CurDate As Date
        Dim Answers As Boolean

        CurDate = Now
        ldap = "LDAP://" & DomainName & "/" & OU_Name

        ' set our starting place to search
        entry = New DirectoryEntry(ldap)
        srch = New DirectoryServices.DirectorySearcher(entry)
        srch.Filter = "(ObjectCategory=computer)"
        ' A work around for a bug... this shouldn't be needed
        srch.PageSize = 1000

        ' OK, let's do it
        For Each result In srch.FindAll()
            de = result.GetDirectoryEntry

            buf = de.Properties("cn").Value.ToString
            If Filter = "" Or Filter.ToUpper = buf.ToUpper Or buf.ToUpper Like Filter.ToUpper Then
                Try
                    ' Next we ping the remote PC to see if it's really on the network
                    Answers = False
                    Try
                        If My.Computer.Network.Ping(buf, 1000) Then
                            Answers = True
                        End If
                    Catch ex As Exception
                    End Try

                    ' add it to our database
                    Record_count = Record_count + 1
                    dr = dt.NewRow
                    dr("PCName") = buf
                    dr("DistinguishedName") = de.Properties("distinguishedName").Value.ToString
                    dr("CurrentDate") = CurDate
                    If Not IsNothing(de.Properties("operatingSystem").Value) Then
                        dr("OSVersion") = CDbl(Split(de.Properties("operatingSystemVersion").Value.ToString, " ")(0))
                    Else
                        dr("OSVersion") = 0.0
                    End If
                    dr("OSType") = BuildServiceType(de.Properties("servicePrincipalName").Value)
                    If de.Properties.Contains("description") AndAlso de.Properties("description").Value.ToString <> "" Then
                        dr("PCComment") = de.Properties("description").Value.ToString
                    End If
                    dr("AnswersPing") = Answers
                    dt.Rows.Add(dr)

                    ' keep them entertained
                    Console.Write(".")
                Catch ex As Exception
                    Console.Write("!")
                    Debug.WriteLine(buf & ": " & ex.Message)
                End Try
            End If
        Next
    End Sub

    Private Function BuildServiceType(ByVal t As Object) As String
        Dim temp As New ArrayList
        Dim obj As Object
        Dim service, ans As String

        If IsNothing(t) Then
            Return ""
        End If

        For Each obj In CType(t, Object())
            service = obj.ToString.Split("/"c)(0)
            If Not temp.Contains(service) Then
                temp.Add(service)
            End If
        Next

        ans = ""
        For Each service In temp
            ans &= service & ","
        Next

        Return ans.TrimEnd(","c)
    End Function
End Class
